=== debian/changelog ===
python3.10 (3.10.4-3) unstable; urgency=medium

  * Build a python3.10-nopie package, diverting the python3.10
    executable.
  * Build the python3.10 interpreter with PIE enabled. Closes: ##919134.
    LP: #1452115.
  * Fix build on ia64 (Adrian Glaubitz). Closes: #1008576.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Apr 2022 11:04:19 +0200

python3.10 (3.10.4-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Avoid infinite recursion in _distutils_system_mod when
    SETUPTOOLS_USE_DISTUTILS=local.
  * Avoid crashing in `_distutils_system_mod` if we find an older version of
    distutils (from before `_distutils_system_mod` was implemented).

 -- Matthias Klose <doko@debian.org>  Fri, 01 Apr 2022 17:03:31 +0200

python3.10 (3.10.4-1) unstable; urgency=medium

  * Python 3.10.4 release.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Mar 2022 14:07:27 +0100

python3.10 (3.10.3-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Change the "include" and "platinclude" paths in the "posix_local"
    scheme to refer to the location of Python's headers, not the install
    location for modules' C headers. Closes: #1007966

  [ Matthias Klose ]
  * Allow to build with PIE enabled by default, and build a separate
    python3.10-nopie package. Not yet enabled for Debian.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Mar 2022 12:42:32 +0100

python3.10 (3.10.3-1) unstable; urgency=medium

  * Python 3.10.3 release.

 -- Matthias Klose <doko@debian.org>  Wed, 16 Mar 2022 18:19:40 +0100

python3.10 (3.10.2-7) unstable; urgency=medium

  [ Stefano Rivera ]
  * Use the same is_virtual_environment() proposed in PEP 668 across the site,
    sysconfig, and distutils modules. Stop checking for PYTHONUSERBASE or
    VIRTUAL_ENV environment variables.
  * Correct assertion descriptions in module-install-* autopkgtests.
  * Extend module-install-* autopkgtests to catch the issues fixed in -6:
    - Check the directory that the modules are installed to.
    - Check editable installs.
    - Check pip-driven PEP-517 installs.
    - Check that virtualenvs are seeded with the correct layout.
  * Re-enable module-install-virtualenv.

 -- Matthias Klose <doko@debian.org>  Mon, 14 Mar 2022 06:18:40 +0100

python3.10 (3.10.2-6) unstable; urgency=medium

  [ Matthias Klose ]
  * Update to the 3.10 branch 2022-03-13.
  * Add the test_multiprocessing_fork test to the failing autopkg tests,
    and run them with a 2h timeout.
  * Don't run the test_multiprocessing tests in the profile run.

  [ Stefano Rivera ]
  * Re-add accidentally dropped /local/ to paths in distutils unix_local
    scheme.
  * Add missing /local/ to data path in sysconfig posix_local scheme.
    LP: #1964588.
  * Improve support for setuptools > 60's bundled distutils in
    _distutils_system_mod, supporting a wider range of versions and more
    reliably selecting the posix_local scheme. Closes: #1004149.
  * Use the same heuristics for scheme selection in sysconfig, as we use in
    distutils.command.install. Closes: #1006707, LP: #1962791.
  * Run the test suite with a 1hr timeout per module. Closes: #1000188.

 -- Matthias Klose <doko@debian.org>  Sun, 13 Mar 2022 07:20:35 +0100

python3.10 (3.10.2-5) unstable; urgency=medium

  * Fix the marshal test after applying the fix for #1004558.

 -- Matthias Klose <doko@debian.org>  Sat, 26 Feb 2022 09:21:15 +0100

python3.10 (3.10.2-4) unstable; urgency=medium

  * Provide a _distutils_system_mod module to customize distutils behaviour
    for Debian's install layout (Stefano Rivera).

 -- Matthias Klose <doko@debian.org>  Fri, 25 Feb 2022 22:04:33 +0100

python3.10 (3.10.2-3) unstable; urgency=medium

  * Apply again the updated sysconfig-debian-schemes patch (Alexandre Ghiti).

 -- Matthias Klose <doko@debian.org>  Fri, 25 Feb 2022 21:13:53 +0100

python3.10 (3.10.2-2) unstable; urgency=medium

  * Make test suite support Expat >=2.4.5. Closes: #1006219.
  * Build again using readline instead of libedit. Closes: #1005761.
  * Serialize frozenset elements deterministically, taken from the trunk.
    Closes: #1004558.

 -- Matthias Klose <doko@debian.org>  Tue, 22 Feb 2022 14:57:42 +0100

python3.10 (3.10.2-1) unstable; urgency=medium

  * Python 3.10.2 release.

  [ Stefano Rivera ]
  * Migrate to individual wheel packages. Drop ensurepip-pkg-resources.diff,
    pkg_resources is now shipped in the setuptools wheel. (Closes: #1003573)
  * Mark module-install-user autopkgtest allow-stderr. (Closes: #1001722)

 -- Matthias Klose <doko@debian.org>  Sun, 16 Jan 2022 18:11:27 +0100

python3.10 (3.10.1-5) unstable; urgency=medium

  * Allow stderr in the module-install-venv autopkg test.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Jan 2022 16:42:55 +0100

python3.10 (3.10.1-4) unstable; urgency=medium

  * Also apply the openssl-3 patch.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Jan 2022 15:08:13 +0100

python3.10 (3.10.1-3) unstable; urgency=medium

  * d/p/openssl-3.0.1-version-check.diff: cherry-picked from upstream
    to fix the test suite against OpenSSL 3.0.1 (Simon Chopin).
    LP: #1956765.

 -- Matthias Klose <doko@debian.org>  Mon, 10 Jan 2022 12:07:18 +0100

python3.10 (3.10.1-2) unstable; urgency=medium

  * Run the module-install-local test with allow-stderr. Closes: #1001722.

 -- Matthias Klose <doko@debian.org>  Fri, 17 Dec 2021 00:04:04 +0100

python3.10 (3.10.1-1) unstable; urgency=medium

  * Python 3.10.1 release.
  * Depend on media-types instead of mime-support. Closes: #1000366.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 07 Dec 2021 14:27:28 +0100

python3.10 (3.10.0-5) unstable; urgency=medium

  * Build again the _dbm extension using libdb-dev.

 -- Matthias Klose <doko@debian.org>  Wed, 17 Nov 2021 07:49:13 +0100

python3.10 (3.10.0-4) unstable; urgency=medium

  * Revert the backport for issue #45235 (argparse does not preserve
    namespace with subparser defaults).


