## python3.10 3.10.7

=== debian/changelog ===
python3.10 (3.10.7-1) unstable; urgency=medium

  * Python 3.10.7 release.

 -- Matthias Klose <doko@debian.org>  Thu, 08 Sep 2022 16:34:29 +0200
