=== debian/control ===
--- 
+++ 
@@ -19,8 +19,8 @@
   systemtap-sdt-dev
 Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
 Standards-Version: 4.6.0
-Vcs-Browser: https://salsa.debian.org/cpython-team/python3
-Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
+Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.10
+Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.10
 XS-Testsuite: autopkgtest
 
 Package: python3.10
