=== debian/rules ===
--- 
+++ 
@@ -206,7 +206,7 @@
   endif
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
   with_lto := yes
 endif
 
@@ -231,3 +231,4 @@
     with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
 			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
     ifeq ($(with_fat_lto),yes)
+      LTO_CFLAGS += -ffat-lto-objects
