## python3.10 3.10.11

=== debian/changelog ===
python3.10 (3.10.11-1) unstable; urgency=medium

  * Python 3.10.11 release.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Apr 2023 07:50:02 +0200

python3.10 (3.10.10-2) unstable; urgency=medium

  * Fix removing Debian build flags from _sysconfigdata.
  * Fix error message for 'python3 -m venv dir`, when python3-venv
    is not installed. Closes: #1026268.

 -- Matthias Klose <doko@debian.org>  Fri, 24 Feb 2023 12:37:34 +0100

python3.10 (3.10.10-1) unstable; urgency=medium

  * Python 3.10.10 release.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Feb 2023 08:54:04 +0100

python3.10 (3.10.9-1) unstable; urgency=medium

  * Python 3.10.9 release.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Dec 2022 14:47:07 +0100

python3.10 (3.10.8-3) unstable; urgency=medium

  * Fix valgrind detection.

 -- Matthias Klose <doko@debian.org>  Fri, 04 Nov 2022 10:21:25 +0100

python3.10 (3.10.8-2) unstable; urgency=medium

  * Fix GDB auto-load files. Closes: #1017913.
  * Add support for systemd-binfmt. Closes: #1012377.
  * Address privilege escalation via multiprocessing forkserver start method:
    - debian/patches/CVE-2022-42919.patch: don't use Linux abstract sockets
      in Lib/multiprocessing/connection.py.
    - CVE-2022-42919
  * libpython3.10-dev: Install Python.asdl and python.gram. Closes: #1022951.
  * Configure the python3-dbg interpreter --with-valgrind. Closes: #1006315.
  * Bump standards version.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Nov 2022 16:17:13 +0100

python3.10 (3.10.8-1) unstable; urgency=medium

  * Python 3.10.8 release.

 -- Matthias Klose <doko@debian.org>  Mon, 24 Oct 2022 12:07:16 +0200

python3.10 (3.10.7-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * autopkgtests: Support python3-setuptools >= 64, which does PEP-660
    editable installs.

 -- Matthias Klose <doko@debian.org>  Sat, 01 Oct 2022 06:31:04 +0200
